/*
 * Radio
 *
 * For accessibility, we provide a style for focus only on Tab,
 * for that add the javascript polyfill for focus-visible
 * (https://github.com/WICG/focus-visible).
 *
 * Index
 * - Radio
 * - Label
 * - Error
 * - Position
 */

/* RADIO
 -------------------- */

:host {
  position: relative;
  display: block;
  margin-bottom: 1.5rem;
  font-family: var(--road-font, sans-serif);
  font-size: var(--road-body-medium);
  line-height: 1.5;
  color: var(--road-on-surface);
}

/**
 * Inline radio
 */

:host(.form-radio-inline) {
  display: inline-flex;
  flex-wrap: wrap;
  align-items: center;
  margin-right: 1.5rem;
  margin-bottom: 0;
}

/**
 * Hide input
 */

.form-radio-input {
  position: absolute;
  z-index: -1;
  width: 20px;
  height: 20px;
  opacity: 0;
}

.form-radio-input:disabled {
  z-index: 1;
  width: 100%;
  cursor: not-allowed;
}

/* LABEL
 -------------------- */

.form-radio-label {
  position: relative;
  display: inline-flex;
  align-items: flex-start;
  margin: 0;
  cursor: pointer;
  -webkit-tap-highlight-color: rgba(0, 0, 0, 0);
}

.form-radio-label::before {
  box-sizing: border-box;
  display: block;
  flex-shrink: 0;
  width: 1.25rem;
  height: 1.25rem;
  margin: 0.1rem 0.75rem 0 0;
  content: "";
  background: var(--road-surface);
  border: 1px solid var(--road-input-outline);
  border-radius: 50%;
  transition: border-color 0.2s ease-in-out;
}

.form-radio-label-span {
  margin-left: var(--road-spacing-02);
  color: var(--road-on-surface-weak);
}

.form-radio-label::after {
  position: absolute;
  top: 0.285rem;
  left: 0.1875rem;
  box-sizing: border-box;
  display: block;
  width: 0.875rem;
  height: 0.875rem;
  content: "";
  background: var(--road-grey-60);
  border: none;
  border-radius: 50%;
  transition: background 0.2s ease-in-out, transform 0.2s ease-in-out;
  transform: scale(0);
  transform-origin: 50% 50%;
}

/**
 * Hover state
 */

@media (hover: hover) {

  .form-radio-input ~ .form-radio-label:hover::before {
    border-color: var(--road-input-surface);
  }

  .form-radio-input:checked ~ .form-radio-label:hover::after {
    background: var(--road-input-surface-variant);
  }
}

/**
 * Checked state
 */

.form-radio-input:checked ~ .form-radio-label::after {
  background: var(--road-input-surface);
  opacity: 1;
  transform: scale(1);
}

/**
 * Focus on Tab
 */

.form-radio-input.focus-visible ~ .form-radio-label::before {
  box-shadow: 0 0 0 0.125rem var(--road-grey-100-new), 0 0 0 0.1875rem var(--road-input-outline-variant);
}

.form-radio-input.focus-visible:checked ~ .form-radio-label::after {
  background: var(--road-primary-700);
}

/**
 * Disabled state
 */

.form-radio-input:disabled ~ .form-radio-label,
.form-radio-input[readonly] ~ .form-radio-label {
  cursor: not-allowed;
}

.form-radio-input:disabled ~ .form-radio-label::before,
.form-radio-input[readonly] ~ .form-radio-label::before {
  background: var(--road-on-surface-disabled);
  border: none;
}

.form-radio-input:disabled ~ .form-radio-label::after,
.form-radio-input[readonly] ~ .form-radio-label::after {
  background: var(--road-grey-60);
}

/* ERROR
 -------------------- */

.form-radio-input.is-invalid ~ .form-radio-label::before {
  border-color: var(--road-danger-outline);
}

/* POSITION
 -------------------- */

.form-radio-inverse {
  display: flex;
  flex-direction: row-reverse;
  justify-content: space-between;
}

.form-radio-inverse::before {
  margin: 0 0 0 1rem;
}

.form-radio-inverse::after {
  right: 0.1875rem;
  left: auto;
}
